
%if 0

lDOS DOSCODE entrypoint handling
 by E. C. Masloch, 2018--2025

Usage of the works is permitted provided that this
instrument is retained with the works, so that any entity
that uses the works is notified of this instrument.

DISCLAIMER: THE WORKS ARE WITHOUT WARRANTY.

%endif

usesection DOSCODETABLE
global doscode_start
doscode_start:					; must be start of segment

	times DOSCODE_HMA_OFFSET - 16 db 38	; prefix that is unused,
						;  and not relocated
 extern afterdoscodelabel
 global doscode_mcb
doscode_mcb:
	istruc MCB
at mcbSignature,db 'M'
at mcbOwner,	dw 8
at mcbSize,	dw afterdoscodelabel - DOSCODE_HMA_OFFSET wrt DOSCODEGROUP
at mcbName,	db "S"
at smcbType,	db S_DOSCODE
	iend

		; (lMS-DOS: Comment not applicable)
		; The following table and function is used by devicerelocate
		;  even if DOSCODE is merged into DOSENTRY (!_RELOCATEDOSCODE).

	write_entrypoint_list ENTRYPOINT_LIST


%if _RELOCATEDOSCODE && _DOSCODEHMA
	_fill 0C0h + DOSCODE_HMA_start_at, 90h, doscode_start
hma_call5:
 assume ds:nothing, es:nothing, ss:nothing
	jmp DOSENTRY:call5
%endif


		; INP:	byte [cs:ip] = displacement in doscode_entrypoint_list
		;	word [DOSCODE:(displaced)]
		;	 = relocated entry address
		;	word [DOSCODE:(displaced + 2)]
		;	 = optional pointer to device function table
		;	byte [DOSCODE:(displaced + 4)]
		;	 = optional device unit
		;	ss:(sp + 6) -> arbitrary stack of entrypoint
		;	word [ss:sp + 4] = entrypoint's ip,
		;	word [ss:sp + 2] = entrypoint's cs,
		;	word [ss:sp + 0] = original ax value,
relocated_relocatedentry:
 assume ds:nothing, es:nothing, ss:nothing
	 pushf
	lframe 0
	lpar word, entrypoint_ip
	lpar word, entrypoint_cs
	lpar word, orig_ax
	lpar word, orig_fl
	lenter
	push ds
	push si

	mov ah, 0
	mov ds, word [bp + ?entrypoint_cs]
 assume ds:nothing
	mov si, word [bp + ?entrypoint_ip]
%if 0
	cld
	inc si
	lodsb
	cmp al, 0CCh	; overwritten by debugger ?
	jne @F		; no -->
	int3		; break to make it remove the breakpoint
	dec si
	lodsb		; reload the byte
	cmp al, 0CCh
	jne @F
%else
	mov al, [si + 1]
	jmp @F
%endif

.error:
	cld
	mov si, doscode_msg.error_common	; access with cs
	call doscode_disp_msg_cs
	mov si, doscode_msg.error_table		; access with cs
..@halt:
	call doscode_disp_msg_cs
	mov si, doscode_msg.error_after		; access with cs
	call doscode_disp_msg_cs
.loop:
	int3
	xor ax, ax
	int 16h
	jmp .loop

@@:
	push cs
	pop ds
 assume ds:DOSCODEGROUP

	add ax, doscode_entrypoint_list
	cmp ax, doscode_entrypoint_list.end
	jae .error
	xchg ax, si

	lodsw		; get relocated entry address
%if 0
	cmp ax, DEVStrategy		; set ZF iff DEVStrategy
%else
	test ax, ax
%endif

	xchg word [bp + ?orig_ax], ax	; store address in ?orig_ax, ax = orig ax

	 push ax
	lodsw
	mov word [bp + ?entrypoint_ip], ax

	mov ah, 0
	lodsb
	mov word [bp + ?entrypoint_cs], ax
	 pop ax

	pop si
	pop ds
 assume ds:nothing
	lleave
	je .is_dev_strat		; dispatch based on ZF
	popf				; (fl = ?orig_fl = fl)
	retn 4				; (ip = ?orig_ax = address)

.is_dev_strat:
	popf
	retn


doscode_disp_msg_cs:
 assume ds:nothing, es:nothing, ss:nothing
	push ax
@@:
	cs lodsb
	test al, al
	jz @F
	call doscode_disp_al
	jmp short @B


doscode_disp_al:
 assume ds:nothing, es:nothing, ss:nothing
	push ax
	push bx
	push bp
	mov ah, 0Eh
	mov bx, 7
	int 10h
	pop bp
	pop bx
@@:
	pop ax
	retn


doscode_disp_dxax_hex:	; dx:ax
 assume ds:nothing, es:nothing, ss:nothing
		xchg ax, dx
		call doscode_disp_ax_hex
		xchg ax, dx
doscode_disp_ax_hex:	; ax
 assume ds:nothing, es:nothing, ss:nothing
		xchg al, ah
		call doscode_disp_al_hex
				; display former ah
		xchg al, ah	;  and fall trough for al
doscode_disp_al_hex:	; al
 assume ds:nothing, es:nothing, ss:nothing
		push cx
		mov cl, 4
		ror al, cl
		call doscode_disp_al_lownibble_hex
				; display former high-nibble
		rol al, cl
		pop cx
				;  and fall trough for low-nibble
doscode_disp_al_lownibble_hex:
 assume ds:nothing, es:nothing, ss:nothing
		push ax		; save ax for call return
		and al, 00001111b
				; high nibble must be zero
		add al, '0'	; if number is 0-9, now it's the correct character
		cmp al, '9'
		jna .decimalnum	; if we get decimal number with this, ok -->
		add al, 7	;  otherwise, add 7 and we are inside our alphabet
 .decimalnum:
		call doscode_disp_al
		pop ax
		retn


relocated shellreturned
 assume ds:nothing, es:nothing, ss:nothing
	sti
	cld
	jnc .returned
	mov si, doscode_msg.error_shell_failed.1	; access with cs
	call doscode_disp_msg_cs
	call doscode_disp_ax_hex
	mov si, doscode_msg.error_shell_failed.2	; access with cs
	jmp @F
.returned:
	mov si, doscode_msg.error_shell_returned	; access with cs
@@:
	jmp ..@halt


doscode_msg:
.error_common:	asciz "DOSCODE error: "
.error_table:	asciz "Invalid doscode_entrypoint_list reference."
.error_shell_failed.1:	asciz "Initial shell process execution failed! Code="
.error_shell_failed.2:	asciz "h."
.error_shell_returned:	asciz "Initial shell process returned!"
.error_after:	asciz 13,10,"System halted. "
